<?
#-------------------------------#
# W3matter Meta Search Engine 
#-------------------------------#
# Author: Ericson C. Smith
# Email : info@w3matter.com	
# Copyright (C) 2002
#-------------------------------#
# This program shall not be     
# distributed without the
# consent of the author.
#-------------------------------#

#- Include the settings file
include_once("xtpl.php");

#- Setup the sessions
session_start();
if(!$HISTORY)
{	
	session_register("HISTORY");
	$HISTORY = array();
}

if($search)
	$c = "search";
if($redir)
	$c = "redir";
 
#- Decide what to do
switch($c)
  {
    case "search":
    	search();
    	break;
    	
    case "redir":
	redir();
	break;

    default:
        lib_main("Enter your search term","Search"); 		
        break;
  }

exit;



#-----------------------------#
# Redirect a search
#-----------------------------#
function redir()
{
	global $redir;

	list($title, $url) = explode("|", $redir);
	$url = urldecode($url);
	lib_history("S", $title, $url);
	header("Location: $url");
	exit;
}


#-----------------------------#
# Do the search & display
#-----------------------------#
function search()
{
	global $KEYWORD, $PAGE, $QUEUE, $HISTORY, $PAGESIZE, $RESULTS;
	global $HTTP_GET_VARS, $HISTORY, $PLUG;

	#- Get the vars
	$PAGE = $HTTP_GET_VARS['page'];
	$PAGE = iif(!$PAGE, 1, $PAGE);
	$KEYWORD = $HTTP_GET_VARS['search'];
	$PLUG = $HTTP_GET_VARS['plug'];
	$ky = urlencode($KEYWORD);

	#- Insert this word into the history buffer
	lib_history("K",$ky,$ky);
	
	#- Meta-search for the results
	if(!count($PLUG))
	{
		$PLUG[] = "dmoz.plugin";
	}

	foreach($PLUG as $rec)
	{
		include_once("./plugins/$rec");
	}
	reset($PLUG);

	#- How many results?
	$RESULTS = count($QUEUE);

	#- Format the results using the results template
	if($RESULTS)
	{
		#- Order results by bid
		sort_results();
		
		$tpl = new XTemplate("search.html");
		$tpl->assign("PAGE", $page);

		// Setup regex
		$regex = "";
		if(count($QUEUE) > 0)
		{
			$w = stripslashes($ky);
			$w = str_replace(array('"', "'", "and", "or", "not", "nand"), "", $w);
			$k = preg_split('/\W+/', $w,  -1, PREG_SPLIT_NO_EMPTY);
			if(count($k) > 0)
			{
				$r = implode("|", $k);
				$regex = "/($r)/i";
			}
		}

		$x=0;
		foreach($QUEUE as $rec)
		{
			$x++;
			
			$elist = array();
			foreach($rec[engine] as $e)
				$elist[] = $e;
			$engines = join(", ",$elist);
			$url = $rec[url];
			$title = $rec[title];
			if($rec[bid] <= 0)
				$url = "index.php?redir=".urlencode($title)."|".urlencode($url);
			else
				$url = "$url";
				
			$str = 	wordwrap($rec[description],80,"<br>",1);	
			$str = preg_replace($regex, "<b>\$1</b>", $str);
			$rec[title] = preg_replace($regex, "<b>\$1</b>", $rec[title]);
			$d = explode("|", urldecode($url));
			$dispurl = $d[1];
			
			$tpl->assign("URL",$url);
			$tpl->assign("DISPURL", substr($dispurl,0,75));
			$tpl->assign("TITLE", $rec[title]);
			$tpl->assign("DESCRIPTION", $str);
			$tpl->assign("ENGINES", $engines);
			$tpl->parse("main.results");
		}
	
		if($x > 10)
		{
			#- Flatten plugin list again (sigh)
			$pluglist = "plug[]=" . implode("&plug[]=", $PLUG);

			$ppage = $PAGE -1;
			$npage = $PAGE +1;
			$tpl->assign("NEXT","<a href=index.php?search=$ky&page=$npage&$pluglist>More >></a>");
			if($PAGE > 1)
				$tpl->assign("PREV","<a href=index.php?search=$ky&page=$ppage&$pluglist><< Previous</a>");
		}
	
		$tpl->assign("PAGE", $PAGE);	
		$tpl->assign("KEYWORD", $KEYWORD);
		$tpl->parse("main");
		$results = $tpl->text("main");
	}
	else
	{
		$results = "No results were found. Please try your search again";
	}	

	lib_main($results,"Search Results :: $KEYWORD");	
}


#-----------------------------#
# Sort the results returned   
#-----------------------------#
function sort_results()
{
	global $QUEUE;
	$SORTER = array();
	
	reset($QUEUE);
	while(list($key,$val) = each($QUEUE))
		{
			$SORTER[] = $val[bid];
		}

	reset($QUEUE);
	array_multisort(&$QUEUE,SORT_DESC, SORT_NUMERIC, &$SORTER, SORT_DESC, SORT_NUMERIC);		
	
	return(1);
}


#-----------------------------#
# Retrieve the list of plugins
# that were discovered       
#-----------------------------#
function plugger()
{
	$plugins = array();

	$handle = opendir("./plugins");
	while(false !== ($file = readdir($handle)))
	{
		if(preg_match('/\.plugin$/i',$file))
		{
			$plugins[] = $file;
		}
	}
	closedir($handle);

	return($plugins);
}#- end plugger


#-----------------------------------#
# Insert a new record into the queue
#-----------------------------------#
function qinsert($url="",$title="",$description="",$engine="",$position=0,$bid=0,$redirect="")
{
	global $QUEUE;
	
	if(!$url)
	  	return(0);
	
	if(!$title)
		$title = "[No title]";
	
	if(!$description)
		$description = "&nbsp;";
	
	if(!$redirect)
		$redirect = $url;

	if($QUEUE[results][$url])
		{
			$QUEUE[$url][engine][] = $engine;
		}
	else
		{
			$QUEUE[$url][url] = $url;
			$QUEUE[$url][title] = trim(strip_tags($title));
			$QUEUE[$url][description] = trim(strip_tags($description));
			$QUEUE[$url][position] = $position;
			$QUEUE[$url][bid] = $bid;
			$QUEUE[$url][redirect] = $redirect;
			$QUEUE[$url][engine][] = $engine;
		}
		
	return(1);
}#- end queue


#- Show the main page
function lib_main($content="", $title="")
{
	global $SEARCH, $HISTORY, $KEYWORD, $PLUG;

	$tpl = new XTemplate("main.html");
	
	$tpl->assign("SEARCH", stripslashes($KEYWORD));
	$tpl->assign("BODY", $content);
	$tpl->assign("PREV", $SEARCH[prev]);
	$tpl->assign("PAGES", $SEARCH[pages]);
	$tpl->assign("NEXT", $SEARCH[next]);

	#- Get the list of plugins to search
	$plugins = plugger();
	$names = array();

	if(!count($PLUG))
		$PLUG[] = "dmoz.plugin";

	foreach($plugins as $rec)
	{
		list($n,$ext) = explode(".", $rec);

		$n = ucfirst(strtolower($n));
		if(in_array($rec,$PLUG))
			$names[] = "<td width=1><input type=checkbox name=\"plug[]\" value=\"$rec\" CHECKED></td><td width=1><font size=1>$n</font>&nbsp;</td>"; 
		else
			 $names[] = "<td width=1><input type=checkbox name=\"plug[]\" value=\"$rec\"></td><td width=1><font size=1>$n</font>&nbsp;</td>";
	}
	$enginelist = "<table width=100%><tr>" . implode("",$names) . "<td>&nbsp;</td></tr></table>";
	$tpl->assign("ENGINELIST", $enginelist);

	#- Is there history?
	if(count($HISTORY))
	{
		$disp = array_slice($HISTORY,-20);
		krsort($disp);
		foreach($disp as $rec)
		{
			if($rec[type] == "S")
			{
				$img = "site.gif";
				$name = substr($rec[name],0,32);
				if(!$name)
				{
					$dom = parse_url($rec[content]);
					$name = $dom[host];
				}
				$content = $rec[content];
			}
			else
			{
				$img = "search.gif";
				$name = urlencode(stripslashes(substr($rec[name],0,32)));
				$content = "index.php?search=$name";
			}

			$tpl->assign("IMG","<img src=$img border=0>");
			$tpl->assign("NAME",$name);
			$tpl->assign("URL",$content);
			$tpl->parse("main.historylist");
		}
	}	
	
	$tpl->parse("main");
	echo $tpl->text("main");
	exit("");
}

#-----------------------------------------#
# iif function                            
#-----------------------------------------#
function iif($condition,$value_true,$value_false)
{
	if($condition)
		return $value_true;
	else
		return $value_false;
}

#-------------------------#
# Grab a page
#-------------------------#
function lib_grab($url="")
{
	$url = @join("",@file($url));
	return($url);
}

#-------------------------#
# Add to history
#-------------------------#
function lib_history($type, $name, $content="")
{
	global $HISTORY;

	$found = 0;
	foreach($HISTORY as $rec)
	{
		if($rec[type] == $type && $rec[content] == $content)
			$found = 1;
	}

	if($found == 0)
	{
		$HISTORY[] = array(type=>$type, name=>urldecode($name), content=>urldecode($content));
	}

	return("");
}

?>
